local function split_lines(str)
  local lines = {}
  -- Include linebreaks in the results
  local line = ""
  for i=1, #str do
    local char = str:sub(i, i)
    line = line .. char
    if char == "\n" or i == #str then
      table.insert(lines, line)
      line = ""
    end
  end
  return lines
end

local function ascii_banana(gui, x, y)
  local frame = (math.floor(GameGetFrameNum() / 2) % 58) + 1
  local t = dofile_once(("mods/banana_of_rectitude/files/ascii_banana/output_%04d.lua"):format(frame))
  lines_cached = lines_cached or {}
  if not lines_cached[frame] then
    local lines = split_lines(t)
    lines_cached[frame] = {}
    for i, line in ipairs(lines) do
      line = line:gsub("\n", "")
      lines_cached[frame][i] = {}
      for i2=1, #line do
        table.insert(lines_cached[frame][i], line:sub(i2, i2))
      end
    end
  end
  for i, line in ipairs(lines_cached[frame]) do
    for i2, ch in ipairs(line) do
      if i < 6 then
        GuiColorSetForNextWidget(gui, 0x89 / 255, 0x49 / 255, 0x0e / 255, 1)
      elseif i < 8 then
        GuiColorSetForNextWidget(gui, 0x9f / 255, 0xdd / 255, 0x19 / 255, 1)
      else
        GuiColorSetForNextWidget(gui, 1, 0.85, 0, 1)
      end
      GuiText(gui, x + (i2-1)*4, y + (i-1) * 10, ch)
    end
  end
end

return function(gui)
  if GlobalsGetValue("banana_of_rectitude_ascii_banana", "0") == "1" then
    ascii_banana_pos_x = ascii_banana_pos_x or -150
    ascii_banana_dir = ascii_banana_dir or 1
    ascii_banana_bounce_times = ascii_banana_bounce_times or 0
    local screen_width, screen_height = GuiGetScreenDimensions(gui)
    ascii_banana_pos_x = ascii_banana_pos_x + ascii_banana_dir * 2
    if (ascii_banana_pos_x + 150 > screen_width and ascii_banana_bounce_times < 2) or (ascii_banana_pos_x < 0 and ascii_banana_bounce_times > 0) then
      ascii_banana_bounce_times = ascii_banana_bounce_times + 1
      ascii_banana_dir = ascii_banana_dir * -1
    end
    ascii_banana(gui, ascii_banana_pos_x, screen_height / 2 - 140)
    if ascii_banana_bounce_times >= 2 and ascii_banana_pos_x > screen_width then
      GlobalsSetValue("banana_of_rectitude_ascii_banana", "0")
---@diagnostic disable-next-line: assign-type-mismatch
      ascii_banana_pos_x = nil
---@diagnostic disable-next-line: assign-type-mismatch
      ascii_banana_dir = nil
---@diagnostic disable-next-line: assign-type-mismatch
      ascii_banana_bounce_times = nil
    end
  end
end
