local utils = dofile_once("mods/banana_of_rectitude/files/utils.lua")
local entity_id = GetUpdatedEntityID()
local explode_count = 1
local var_store = utils.get_variable_storage_component(entity_id, "explode_count")
if var_store then
  explode_count = ComponentGetValue2(var_store, "value_int")
end
local x, y = EntityGetTransform(entity_id)
if explode_count < 5 then
  GamePlaySound("data/audio/Desktop/animals.bank", "animals/blob/duplicate", x, y)
  for i=-1, 1, 2 do
    local new_banana = EntityLoad("mods/banana_of_rectitude/files/banana_grenade.xml", x, y)
    EntityAddComponent2(new_banana, "VariableStorageComponent", {
      name = "explode_count",
      value_int = explode_count + 1,
    })
    utils.seed_with_frame_and_cam_pos(new_banana)
    local angle = math.rad(-90) + Randomf(math.rad(5), math.rad(15)) * i
    local power = Randomf(10, 12) * 40
    PhysicsApplyForce(new_banana, math.cos(angle) * power, math.sin(angle) * power)
    PhysicsApplyTorque(new_banana, Randomf(-math.pi, math.pi) * 10)
    EntityAddComponent2(new_banana, "LuaComponent", {
      script_source_file="mods/banana_of_rectitude/files/banana_grenade_explode.lua",
      execute_every_n_frame=Random(100, 120) * (explode_count == 4 and 2 or 1),
    })
    local item_component = EntityGetFirstComponentIncludingDisabled(new_banana, "ItemComponent")
    if item_component then
      EntityRemoveComponent(new_banana, item_component)
    end
  end
else
  EntityLoad("mods/banana_of_rectitude/files/banana_grenade_explosion.xml", x, y)
end
EntityKill(entity_id)
