if GetUpdatedComponentID() == 0 then
  function throw_item() end
  function item_pickup() end
  return
end

local utils = dofile_once("mods/banana_of_rectitude/files/utils.lua")
local entity_id = GetUpdatedEntityID()
local frame_thrown = GetValueInteger("frame_thrown", math.huge)
local var_store = utils.get_variable_storage_component(entity_id, "frame_thrown")
if var_store then
  frame_thrown = ComponentGetValue2(var_store, "value_int")
  SetValueInteger("frame_thrown", frame_thrown)
  EntityRemoveComponent(entity_id, var_store)
end

function throw_item(from_x, from_y, to_x, to_y)
  frame_thrown = GameGetFrameNum()
  SetValueInteger("frame_thrown", frame_thrown)
end

function item_pickup(entity_item, entity_pickupper, item_name)
  frame_thrown = math.huge
  SetValueInteger("frame_thrown", frame_thrown)
end

if frame_thrown + 60 <= GameGetFrameNum() then
  local entity_id = GetUpdatedEntityID()
  local x, y = EntityGetTransform(entity_id)
  local new_banana = EntityLoad("mods/banana_of_rectitude/files/banana_grenade.xml", x, y - 5)
  local vel_comp = EntityGetFirstComponentIncludingDisabled(new_banana, "VelocityComponent")
  if vel_comp then
    utils.seed_with_frame_and_cam_pos()
    local angle = math.rad(-45)  + Randomf(math.rad(90))
    local power = Randomf(30, 50)
    ComponentSetValue2(vel_comp, "mVelocity", math.cos(angle) * power, math.sin(angle) * power)
  end
  EntityAddComponent2(new_banana, "VariableStorageComponent", {
    name = "frame_thrown",
    value_int = GameGetFrameNum(),
  })
  frame_thrown = math.huge
  SetValueInteger("frame_thrown", frame_thrown)
end
