local utils = dofile_once("mods/banana_of_rectitude/files/utils.lua")

function kick( entity_who_kicked )
  local entity_id = GetUpdatedEntityID()
  -- Only react when getting kicked, not when the player kicks while holding it,
  -- so check if it's in world, making the component enabled_in_world only doesn't work
  -- since script_kick runs even when the component is disabled
  if EntityGetRootEntity(entity_id) == entity_id then
    local x, y = EntityGetTransform(entity_id)
    local banana_x = tonumber(GlobalsGetValue("banana_of_rectitude_banana_x", "0")) or 0
    local banana_y = tonumber(GlobalsGetValue("banana_of_rectitude_banana_y", "0")) or 0
    local portal_a = utils.spawn_teleport_portal(x, y - 50, banana_x, banana_y, "To the Banana of Rectitude")
    local portal_b = utils.spawn_teleport_portal(banana_x + 50, banana_y - 50, x, y, "Back to whence you came")
    local portal_id = tonumber(GlobalsGetValue("banana_of_rectitude_banana_hearthstone_latest_portal_id", "0"))
    portal_id = portal_id + 1
    for i, v in ipairs({ portal_a, portal_b }) do
      EntityAddComponent2(v, "VariableStorageComponent", {
        name="banana_hearthstone_portal_id",
        value_int=portal_id
      })
      EntityAddComponent2(v, "LuaComponent", {
        script_source_file="mods/banana_of_rectitude/files/hearthstone_portal_check.lua",
        execute_every_n_frame=5,
      })
    end
    GlobalsSetValue("banana_of_rectitude_banana_hearthstone_latest_portal_id", tostring(portal_id))
    EntityKill(entity_id)
  end
end