local function destroy_gui()
  if gui then
    GuiDestroy(gui)
    gui = nil
  end
end

function enabled_changed(entity_id, is_enabled)
  if not is_enabled then
    destroy_gui()
  end
end

local dialog_system = dofile_once("mods/banana_of_rectitude/lib/DialogSystem/dialog_system.lua")

local orig_wake_up_waiting_threads = wake_up_waiting_threads
-- With enable_coroutines="1", this gets called every frame, even with execute_every_frame="-1"
-- This is a method discovered by dextercd to detect when a script gets removed
function wake_up_waiting_threads(...)

orig_wake_up_waiting_threads(...)
dofile_once("data/scripts/lib/utilities.lua")
local EZMouse = dofile_once("mods/banana_of_rectitude/lib/EZMouse/EZMouse.lua")("mods/banana_of_rectitude/lib/EZMouse/")
local utils = dofile_once("mods/banana_of_rectitude/files/utils.lua")
dialog_system.distance_to_close = math.huge

local function end_call()
  call_in_progress = false
end

widget = widget or EZMouse.Widget({
  x = 350, y = 100, z = 1,
  width = 50 - 5, height = 120 - 60,
  draggable = true, enabled = true,
})

local id = 1
local function new_id()
  id = id + 1
  return id
end

local phone_x, phone_y = widget.x, widget.y

dialog = dialog or nil
number = number or ""

local function play_sound(sound)
  local cam_x, cam_y = GameGetCameraPos()
  GamePlaySound("mods/banana_of_rectitude/audio/banana_of_rectitude.bank", sound, cam_x, cam_y)
end

local function dial_number(n)
  if call_in_progress then return end
  if number == "555" then
    number = number .. "-"
  end
  if #number < 8 then
    number = number .. n
  end
end

local valid_numbers = {}
valid_numbers["911"] = function()
  dialog = dialog_system.open_dialog({
    portrait = "mods/banana_of_rectitude/files/stevari_portrait.png",
    portrait_overlay = "mods/banana_of_rectitude/files/banana_phone_gui/portrait_screen_overlay.xml",
    name = "Stevari",
    text = "Yes hello who dis?",
    options = {
      { text = "I would like to report a crime" },
      {
        text = "Haha prank call",
        func = function(dialog)
          dialog.close()
          dofile_once("data/scripts/buildings/temple_check_for_leaks.lua")
          local player = EntityGetWithTag("player_unit")[1]
          local x, y = EntityGetTransform(player)
          material_area_checker_failed(x, y - 30)
        end
      }
    },
    on_closed = end_call
  })
end
valid_numbers["420"] = function()
  dialog = dialog_system.open_dialog({
    portrait = "mods/banana_of_rectitude/files/banana_phone_gui/smonke_portrait.png",
    portrait_overlay = "mods/banana_of_rectitude/files/banana_phone_gui/portrait_screen_overlay.xml",
    name = "Smonke",
    text = [[
      Duuuude, I was totally in the middle of a cosmic journey.
      What's the sitch?
    ]],
    options = {
      { text = "Sorry, wrong number" },
    },
    on_closed = end_call
  })
end
valid_numbers["555-2368"] = function()
  local player = EntityGetWithTag("player_unit")[1]
  local x, y = EntityGetTransform(player)
  -- Try to find ghosts in radius
  local ghosts = {}
  for i, v in ipairs(EntityGetInRadiusWithTag(x, y, 300, "enemy")) do
    local genome_data_component = EntityGetFirstComponentIncludingDisabled(v, "GenomeDataComponent")
    local is_ghost_herd = false
    if genome_data_component then
      local herd_id = ComponentGetValue2(genome_data_component, "herd_id")
      is_ghost_herd = HerdIdToString(herd_id) == "ghost"
    end
    if is_ghost_herd or EntityGetComponentIncludingDisabled(v, "GhostComponent") then
      table.insert(ghosts, v)
    end
  end
  local option = {
    text = "Help, there is a spook in my pants!",
    func = function(dialog)
      dialog.show({
        text = [[
          Please don't ever call here again.
        ]],
        options = {
          {
            text = "No promises"
          }
        },
      })
    end
  }
  if #ghosts > 0 then
    option = {
      text = "HELP, THERE IS A GHOSSSST!!",
      func = function(dialog)
        dialog.show({
          text = [[
            We will send someone over ASAP, hold tight!
          ]],
          options = {
            {
              text = "Thank you"
            }
          },
          on_closed = function()
            local player = EntityGetWithTag("player_unit")[1]
            local x, y = EntityGetTransform(player)
            EntityLoad("mods/banana_of_rectitude/files/spook_squasher_spawner.xml", x, y)
          end
        })
      end
    }
  end
  dialog = dialog_system.open_dialog({
    portrait = "mods/banana_of_rectitude/files/banana_phone_gui/janine_portrait.png",
    portrait_overlay = "mods/banana_of_rectitude/files/banana_phone_gui/portrait_screen_overlay.xml",
    name = "Spook Squashers",
    text = [[Hello, this is the Spook Squashers, how can I help you?]],
    options = {
      option,
      {
        text = "Sorry, wrong number"
      },
    },
    on_closed = end_call
  })
end
valid_numbers["666"] = function()
  local player = EntityGetWithTag("player_unit")[1]
  local x, y = EntityGetTransform(player)
  dialog = dialog_system.open_dialog({
    portrait = "mods/banana_of_rectitude/files/banana_phone_gui/mr_natas_portrait.png",
    portrait_overlay = "mods/banana_of_rectitude/files/banana_phone_gui/portrait_screen_overlay.xml",
    name = "Mr. Natas",
    text = [[
      Return to the surface immediately or you'll be terminated...{@pause 60}
      er...{@pause 60} as in fired!
    ]],
    options = {
      { text = "No" },
    },
    on_closed = end_call
  })
end
valid_numbers["00000000"] = function()
  local player = EntityGetWithTag("player_unit")[1]
  local x, y = EntityGetTransform(player)
  dialog = dialog_system.open_dialog({
    portrait = "mods/banana_of_rectitude/files/portrait.png",
    portrait_overlay = "mods/banana_of_rectitude/files/banana_phone_gui/portrait_screen_overlay.xml",
    name = "Housei No Banana",
    text = "Moshi moshi, banana desu.",
    options = {
      { text = "Nani?" },
      { text = "Eeeeehh!?" },
      { text = "Masaka!" },
    },
    on_closed = end_call
  })
end
valid_numbers["0"] = function()
  dialog_system.images["?"] = "mods/banana_of_rectitude/files/banana_phone_gui/trapped_ghost.xml"
  dialog_system.functions.ghost_scream = function(dialog)
    play_sound("ghost_scream")
    if not GameHasFlagRun("banana_of_rectitude_ghosts_spawned") then
      GameAddFlagRun("banana_of_rectitude_ghosts_spawned")
      local player = EntityGetWithTag("player_unit")[1]
      local x, y = EntityGetTransform(player)
      EntityLoad("mods/banana_of_rectitude/files/ghost_enemy.xml", x, y + 300)
    end
  end
  dialog_system.functions.close = function(dialog)
    async(function()
      wait(400)
      dialog.close()
    end)
  end
  dialog = dialog_system.open_dialog({
    typing_sound = "none",
    portrait = "mods/banana_of_rectitude/files/banana_phone_gui/noise_portrait.xml",
    portrait_overlay = "mods/banana_of_rectitude/files/banana_phone_gui/portrait_screen_overlay.xml",
    name = "???",
    text = "{@func ghost_scream}{@img ?}{@pause 45}{@img ?}{@pause 45}{@img ?}{@pause 45}{@img ?}{@func close}{@pause 30}",
    options = {
      { text = "end cAll END calL enDC aLL eN dC aLl eNd iT ALL" },
    },
    on_closed = end_call
  })
end
valid_numbers["5318008"] = function()
  dialog = dialog_system.open_dialog({
    typing_sound = "one",
    portrait = "mods/banana_of_rectitude/files/banana_phone_gui/awooga_pepe_portrait.png",
    name = "That guy",
    text = "( .)(. )",
    on_closed = end_call
  })
end
valid_numbers["56709"] = function()
  local function make_wrong_option(text)
    return {
      text = text,
      func = function(dialog)
        dialog.show({
          text = "(... they hung up.)",
        })
      end
    }
  end
  dialog = dialog_system.open_dialog({
    typing_sound = "one",
    portrait = "mods/banana_of_rectitude/files/banana_phone_gui/awoo_portrait.png",
    name = "Awoo",
    text = "~Awoooooooooooooooooooo!~",
    options = {
      make_wrong_option("Awoo?"),
      {
        text = "Awooooooo!",
        func = function(dialog)
          dialog.show({
            text = "Awoo?",
            options = {
              {
                text = "Awoooooooooooo...!",
                func = function(dialog)
                  dialog.show({
                    text = "#Awoooooooooooooooooooo!!!!!#",
                    options = {
                      { text = "Awoo!" },
                    },
                    on_closed = function()
                      local player = utils.get_player()
                      if player then
                        local x, y = EntityGetTransform(player)
                        for i=1, 3 do
                          local load_x, load_y = x + (i-2) * 30, y
                          local did_hit, hit_x, hit_y = true, load_x, load_y
                          -- Try to finds a free position, for a max of 10 iterations, go up 10 pixels every fail
                          -- until a free location is found, if there is none found, don't spawn
                          for j=1, 10 do
                            if not did_hit then
                              break
                            else
                              did_hit, load_x, load_y = RaytraceSurfaces(load_x, load_y, load_x, load_y)
                              load_y = load_y - 10
                            end
                          end
                          if not did_hit then
                            local wolf = EntityLoad("data/entities/animals/wolf.xml", load_x, load_y)
                            local genome_data_comp = EntityGetFirstComponentIncludingDisabled(wolf, "GenomeDataComponent")
                            if genome_data_comp then
                              ComponentSetValue2(genome_data_comp, "berserk_dont_attack_friends", true)
                              ComponentSetValue2(genome_data_comp, "herd_id", StringToHerdId("player"))
                            end
                            local damage_model_comp = EntityGetFirstComponentIncludingDisabled(wolf, "DamageModelComponent")
                            if damage_model_comp then
                              ComponentSetValue2(damage_model_comp, "hp", 10) -- 250
                            end
                          end
                        end
                      end
                      valid_numbers["56709"] = nil
                      end_call()
                    end
                  })
                end,
              },
              make_wrong_option("Awoo!"),
              make_wrong_option("Awoooo?!"),
            },
          })
        end,
      },
      make_wrong_option("Awoo..."),
    },
    on_closed = end_call
  })
end

calling_number = calling_number or nil
call_in_progress = call_in_progress or false

if calling_number then
  if utils.wait_frames("calling", 300) then
    play_sound("calling")
  end
  if utils.wait_frames("pickup_call", 180) then
    if valid_numbers[number] then
      valid_numbers[number]()
      play_sound("stop_calling")
      calling_number = nil
    end
  end
end

gui = gui or GuiCreate()
GuiStartFrame(gui)
local screen_width, screen_height = GuiGetScreenDimensions(gui)
if not widget_initialized then
  widget_initialized = true
  widget.constraints = { left = 0, top = 0, right = screen_width - 5, bottom = screen_height - 60, }
  -- widget:AddEventListener("drag_start", function(self, event)
  --   print("Drag started")
  -- end)
  -- widget:AddEventListener("drag", function(self, event)
  --   print("Widget was moved by " .. event.dx .. ", " .. event.dy)
  -- end)
  widget:AddEventListener("drag_end", function(self, event)
    -- Save new position in mod settings when done dragging
    -- print("Drag ended!", self.x, self.y)
    -- ModSettingSet("yourmod.widget_x", self.x)
    -- ModSettingSet("yourmod.widget_y", self.y)
  end)
end
EZMouse.update(gui)

GuiOptionsAdd(gui, GUI_OPTION.NoPositionTween)
GuiZSet(gui, 100)
GuiImage(gui, new_id(), phone_x, phone_y, "mods/banana_of_rectitude/files/banana_phone_big.png", 1, 1, 1)
GuiZSet(gui, 99)
for i=0, 8 do
  local offset_x = (i % 3) * 9
  local offset_y = math.floor(i / 3) * 9
  if GuiImageButton(gui, new_id(), phone_x + 10 + offset_x, phone_y + 72 + offset_y, "", "mods/banana_of_rectitude/files/banana_phone_gui/button_" .. (i+1) .. ".png") then
    play_sound("phone_button")
    dial_number(i + 1)
  end
end
if GuiImageButton(gui, new_id(), phone_x + 10 + 9, phone_y + 72 + 9 * 3, "", "mods/banana_of_rectitude/files/banana_phone_gui/button_0.png") then
  play_sound("phone_button")
  dial_number(0)
end
if GuiImageButton(gui, new_id(), phone_x + 14, phone_y + 62, "", "mods/banana_of_rectitude/files/banana_phone_gui/button_call.png") then
  play_sound("phone_button")
  if not call_in_progress and number ~= "" then
    calling_number = number
    call_in_progress = true
    utils.wait_frames("calling", 30)
    utils.reset_wait_frames("pickup_call")
    utils.seed_with_frame_and_cam_pos()
    utils.wait_frames("pickup_call", Random(60, 300))
  end
end
if GuiImageButton(gui, new_id(), phone_x + 24, phone_y + 62, "", "mods/banana_of_rectitude/files/banana_phone_gui/button_end_call.png") then
  play_sound("phone_button")
  play_sound("stop_calling")
  call_in_progress = false
  calling_number = nil
  number = ""
  if dialog then
    dialog.close()
  end
end

local blink_delay = 30
local offset_x = 0
local offset_y_sub = 0
for i=1, #number do
  local num = number:sub(i, i)
  local offset_y = math.floor(offset_y_sub) * 6
  local alpha = 1
  if call_in_progress and math.floor(GameGetFrameNum() % (blink_delay * 2) / blink_delay) == 0 then
    alpha = 0.5
  end
  GuiImage(gui, new_id(), phone_x + 14 + offset_x, phone_y + 44 + offset_y, "mods/banana_of_rectitude/files/banana_phone_gui/numbers.xml", alpha, 1, 1, 0, GUI_RECT_ANIMATION_PLAYBACK.PlayToEndAndPause, num)
  offset_x = offset_x + 4
  if i % 4 == 0 then
    offset_x = 0
  end
  offset_y_sub = offset_y_sub + 0.25
end
GuiImage(gui, new_id(), phone_x + 13, phone_y + 37, "mods/banana_of_rectitude/files/banana_phone_gui/scanline_overlay.xml", 0.1, 1, 1, 0, GUI_RECT_ANIMATION_PLAYBACK.Loop)

end

if not GetValueBool("initialised", false) then
  -- execute_on_added
  SetValueBool("initialised", true)
else
  -- execute_on_removed
  destroy_gui()
end
