local utils = dofile_once("mods/banana_of_rectitude/files/utils.lua")
local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)
local disk
for i, v in ipairs(EntityGetInRadiusWithTag(x, y, 20, "item_physics")) do
  if EntityGetName(v) == "Disk" and EntityGetParent(v) == 0 then
    disk = v
    break
  end
end

local disk_effects = {
  ["RECTITUDE.EXE"] = function()
    EntityLoad("mods/banana_of_rectitude/files/dancing_banana.xml", x, y - 40)
  end,
  ["VIRUS.EXE"] = function()
    GlobalsSetValue("banana_of_rectitude_virus", "1")
    ModSettingSet("banana_of_rectitude.virus_active", true)
  end,
  ["BANANA.EXE"] = function()
    GlobalsSetValue("banana_of_rectitude_ascii_banana", "1")
  end,
  ["BANANA_V2.EXE"] = function()
    GlobalsSetValue("banana_of_rectitude_3d_banana", "1")
  end,
  ["SPACEWAR.EXE"] = function()
    GameAddFlagRun("banana_of_rectitude_shootemup")
  end
}

if disk then
  local variable_storage_comp = utils.get_variable_storage_component(disk, "disk_type")
  if variable_storage_comp then
    local disk_type = ComponentGetValue2(variable_storage_comp, "value_string")
    if disk_effects[disk_type] then
      disk_effects[disk_type]()
      GamePlaySound("mods/banana_of_rectitude/audio/banana_of_rectitude.bank", "disk_insert", x, y)
      EntityKill(disk)
    end
  end
end
