local utils = dofile_once("mods/banana_of_rectitude/files/utils.lua")
local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)
local child = utils.get_child_by_name(entity_id, "ping_emitter_pos")
if child then
  x, y = EntityGetTransform(child)
end
-- local target_x, target_y = 670, -100
local target_x = tonumber(GlobalsGetValue("banana_of_rectitude_bananomaly_target_x", "-999999"))
local target_y = tonumber(GlobalsGetValue("banana_of_rectitude_bananomaly_target_y", "-999999"))
local max_distance = 1000
local dist_x, dist_y = target_x - x, target_y - y
local dist_to_target = math.sqrt(dist_x^2 + dist_y^2)
dist_to_target = math.min(max_distance, dist_to_target)
local p = 1 - (dist_to_target / max_distance)
p = math.pow(p, 1.3)

local function map(value, old_min, old_max, new_min, new_max)
	return (value - old_min) * (new_max - new_min) / (old_max - old_min) + new_min;
end

local delay = map(p, 0, 1, 300, 10)
local last_execution_frame = GetValueInteger("last_execution_frame", 0)
local next_execution_frame = last_execution_frame + delay
local set_sprite_null = false

if GameGetFrameNum() >= next_execution_frame then
  SetValueInteger("last_execution_frame", GameGetFrameNum())
  GamePlaySound("mods/banana_of_rectitude/audio/banana_of_rectitude.bank", "detector_beep", x, y)
  EntityLoad("mods/banana_of_rectitude/files/bananomaly_detector_ping_ring.xml", x, y)
  if p > 0.98 and not found then
    GamePlaySound("mods/banana_of_rectitude/audio/banana_of_rectitude.bank", "yoshi_score_music", 0, 0)
    EntityLoad("mods/banana_of_rectitude/files/you_found_it.xml", x, y)
    found = true
    for i, comp_id in ipairs(EntityGetComponentIncludingDisabled(entity_id, "LuaComponent") or {}) do
      EntityRemoveComponent(entity_id, comp_id)
    end
    set_sprite_null = true
    local item_component = EntityGetFirstComponentIncludingDisabled(entity_id, "ItemComponent")
    if item_component then
      ComponentSetValue2(item_component, "ui_sprite", "mods/banana_of_rectitude/files/bananomaly_detector_item.png")
    end
  end
end

local sprite_comp = EntityGetFirstComponentIncludingDisabled(entity_id, "SpriteComponent")
if sprite_comp then
  local s = 1
  local p = math.min(max_distance, dist_to_target) / max_distance
  if p < 0.1 then
    s = 3
  elseif p < 0.5 then
    s = 2
  end
  if set_sprite_null then
    ComponentSetValue2(sprite_comp, "rect_animation", "empty")
  else
    ComponentSetValue2(sprite_comp, "rect_animation", tostring(s))
  end
end
