local function destroy_gui()
  if gui then
    GuiDestroy(gui)
    gui = nil
  end
end

function enabled_changed(entity_id, is_enabled)
  if not is_enabled then
    destroy_gui()
  end
end

if not GetValueBool("initialised", false) then
  -- execute_on_added
  SetValueBool("initialised", true)
else
  -- execute_on_removed
  destroy_gui()
end

function wake_up_waiting_threads()
  local entity_id = GetUpdatedEntityID()
  local x, y = EntityGetTransform(entity_id)

  local player = EntityGetInRadiusWithTag(x, y, 20, "player_unit")[1]
  if player then
    gui = gui or GuiCreate()
    GuiStartFrame(gui)
    local screen_width, screen_height = GuiGetScreenDimensions(gui)
    local sign_width, sign_height = GuiGetImageDimensions(gui, "mods/banana_of_rectitude/files/dont_feed_monkey_sign_big.png", 2)
    GuiOptionsAddForNextWidget(gui, 2) -- NonInteractive
    GuiImage(gui, 2, (screen_width - sign_width) / 2, screen_height - sign_height, "mods/banana_of_rectitude/files/dont_feed_monkey_sign_big.png", 1, 2, 2)
  end
end
