local function get_average( t )
  local sum, count = 0, 0
  for k,v in pairs(t) do
    if type(v) == 'number' then
      sum = sum + v
      count = count + 1
    end
  end
  return (sum / count)
end

local function standardDeviation( t )
	local m, vm, result
	local sum, count = 0, 0
  m = get_average( t )
  for k,v in pairs(t) do
    if type(v) == 'number' then
      vm = v - m
      sum = sum + (vm * vm)
      count = count + 1
    end
  end
  result = math.sqrt(sum / (count-1))
  return result
end

local function pack(...)
  return {...}
end

local function measure(name, func, report_frame_interval, resolution)
  report_frame_interval = report_frame_interval or 60
  resolution = resolution or "ms"
	measurings = measurings or {}
	measurings[name] = measurings[name] or {}
  local start = GameGetRealWorldTimeSinceStarted()
  local ret_vals = pack(func())
	table.insert(measurings[name], (GameGetRealWorldTimeSinceStarted() - start))
  if #measurings[name] >= report_frame_interval then
    local resolution_multiplier = resolution == "ms" and 1000 or (1000 * 1000)
    local longest = measurings[name]
    table.sort(longest)
    longest = longest[#longest]
    local sum = 0
    for i, v in ipairs(measurings[name]) do
      sum = sum + v
    end
    print(string.format("=== %s ===", name))
    print(string.format("All %d runs took %.2f%s", #measurings[name], sum * resolution_multiplier, resolution))
		print(string.format("Longest run took %.2f%s", longest * resolution_multiplier, resolution))
		print(string.format("Average run took %.2f%s", get_average(measurings[name]) * resolution_multiplier, resolution))
		print(string.format("Standard deviation %.2f%s", standardDeviation(measurings[name]) * resolution_multiplier, resolution))
		measurings[name] = {}
  end
  return unpack(ret_vals)
end

return measure
