local skill_bonuses = dofile_once("mods/banana_of_rectitude/files/skill_board/skill_bonuses.lua")
local multiplier = skill_bonuses.get_bonus("DamagePercent") / 100 + 1
-- print("DamagePercent: ", tostring(multiplier))
-- Multiplies all damage done by the players projectiles by the skill board bonus

function shot(projectile_entity)
  local projectile_component = EntityGetFirstComponentIncludingDisabled(projectile_entity, "ProjectileComponent")
  if projectile_component then
    local damage = ComponentGetValue2(projectile_component, "damage")
    ComponentSetValue2(projectile_component, "damage", damage * multiplier)
    for _, type in ipairs({"curse", "drill", "electricity", "explosion", "fire", "healing", "ice", "melee", "overeating", "physics_hit", "poison", "projectile", "radioactive", "slice"}) do
      local damage = ComponentObjectGetValue2(projectile_component, "damage_by_type", type)
      ComponentObjectSetValue2(projectile_component, "damage_by_type", type, damage * multiplier)
    end
    local explosion_damage = ComponentObjectGetValue2(projectile_component, "config_explosion", "damage")
    ComponentObjectSetValue2(projectile_component, "config_explosion", "damage", explosion_damage * multiplier)
  end

  local area_damage_component = EntityGetFirstComponentIncludingDisabled(projectile_entity, "AreaDamageComponent")
  if area_damage_component then
    local damage = ComponentGetValue2(area_damage_component, "damage_per_frame")
    ComponentSetValue2(area_damage_component, "damage_per_frame", damage * multiplier)
  end

  local damage_nearby_entities_component = EntityGetFirstComponentIncludingDisabled(projectile_entity, "DamageNearbyEntitiesComponent")
  if damage_nearby_entities_component then
    local damage = ComponentGetValue2(damage_nearby_entities_component, "damage_min")
    ComponentSetValue2(damage_nearby_entities_component, "damage_min", damage * multiplier)
    local damage = ComponentGetValue2(damage_nearby_entities_component, "damage_max")
    ComponentSetValue2(damage_nearby_entities_component, "damage_max", damage * multiplier)
  end

  local lightning_component = EntityGetFirstComponentIncludingDisabled(projectile_entity, "LightningComponent")
  if lightning_component then
    local explosion_damage = ComponentObjectGetValue2(lightning_component, "config_explosion", "damage")
    ComponentObjectSetValue2(lightning_component, "config_explosion", "damage", explosion_damage * multiplier)
  end
end
