local utils = dofile_once("mods/banana_of_rectitude/files/utils.lua")
local entity_id = GetUpdatedEntityID()
local x, y, rot, scale_x, scale_y = EntityGetTransform(entity_id)
local laser = EntityGetAllChildren(entity_id)[1]
local target_x_var_store = utils.get_variable_storage_component(laser, "target_x")
local target_y_var_store = utils.get_variable_storage_component(laser, "target_y")
local target_x, target_y = DEBUG_GetMouseWorld()

local ghosts = {}
for i, v in ipairs(EntityGetInRadiusWithTag(x, y, 500, "enemy")) do
  local genome_data_component = EntityGetFirstComponentIncludingDisabled(v, "GenomeDataComponent")
  local is_ghost_herd = false
  if genome_data_component then
    local herd_id = ComponentGetValue2(genome_data_component, "herd_id")
    is_ghost_herd = HerdIdToString(herd_id) == "ghost"
  end
  if is_ghost_herd or EntityGetComponentIncludingDisabled(v, "GhostComponent") then
    table.insert(ghosts, v)
  end
end

if #ghosts > 0 then
  local ghost = ghosts[1]
  local x, y = EntityGetTransform(ghost)
  target_x = x
  target_y = y
  if utils.wait_frames("damage_" .. tostring(entity_id), 30) then
    local damage = 1
    local damage_model_comp = EntityGetFirstComponentIncludingDisabled(ghost, "DamageModelComponent")
    if damage_model_comp then
      local max_hp = ComponentGetValue2(damage_model_comp, "max_hp")
      damage = max_hp / 10
      -- damage = math.min(20, max_hp / 10)
    end
    EntityInflictDamage(ghost, damage, "DAMAGE_MATERIAL_WITH_FLASH", "", "NORMAL", 0, 0, entity_id)
  end
else
  EntityKill(entity_id)
end

if not target_x_var_store then
  target_x_var_store = EntityAddComponent2(laser, "VariableStorageComponent", { name = "target_x" })
end
if not target_y_var_store then
  target_y_var_store = EntityAddComponent2(laser, "VariableStorageComponent", { name = "target_y" })
end
if not has_target_var_store then
  has_target_var_store = EntityAddComponent2(laser, "VariableStorageComponent", { name = "target_y" })
end
ComponentSetValue2(target_x_var_store, "value_float", target_x)
ComponentSetValue2(target_y_var_store, "value_float", target_y)
if target_x < x then
  EntitySetTransform(entity_id, x, y, rot, math.abs(scale_x) * -1, scale_y)
else
  EntitySetTransform(entity_id, x, y, rot, math.abs(scale_x), scale_y)
end
