local utils = dofile_once("mods/banana_of_rectitude/files/utils.lua")
local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)
local lifetime = 60 * 23 + 30

function get_state()
  local entity_id = GetUpdatedEntityID()
  state = state or {}
  state[entity_id] = state[entity_id] or {}
  return state[entity_id]
end

local state = get_state()

if not GetValueBool("initialized", false) then
  SetValueBool("initialized", true)
  gui = GuiCreate()
else
  state[entity_id] = nil
  GuiDestroy(gui)
end

function wake_up_waiting_threads()
  local phase = state.phase or 1
  local alpha = state.alpha or 0.001
  if phase == 1 then
    alpha = math.min(1, alpha + 0.1)
    if alpha >= 1 then
      phase = 2
      utils.wait_frames("stay_" .. tostring(entity_id), lifetime)
    end
  elseif phase == 2 then
    if utils.wait_frames("stay_" .. tostring(entity_id), lifetime) then
      phase = 3
    end
  elseif phase == 3 then
    alpha = math.min(1, alpha - 0.1)
    if alpha <= 0.001 then
      EntityKill(entity_id)
    end
  end
  state.phase = phase
  state.alpha = alpha
  -- blink in sync with the music, hopefully
  local blink_delay = 44.3
  local frame = math.floor(GameGetFrameNum() % blink_delay / blink_delay * 2) + 1
  GuiStartFrame(gui)
  GuiZSet(gui, 100)
  local screen_width, screen_height = GuiGetScreenDimensions(gui)
  local sprite = "mods/banana_of_rectitude/files/you_found_it_" .. frame .. ".png"
  local img_width, img_height = GuiGetImageDimensions(gui, sprite)
  GuiImage(gui, 2, (screen_width - img_width) / 2, screen_height / 4 - img_height / 2, sprite, alpha, 1, 1)
  if utils.wait_frames("confetti", 30) then
    local cx, cy = GameGetCameraPos()
    SetRandomSeed(cx, cy + GameGetFrameNum())
    for i=1, 4 do
      local random_x_offset = Randomf(-30, 30)
      local particle = EntityLoad("mods/banana_of_rectitude/files/confetti.xml",
        cx + (screen_width / 2 + random_x_offset - 180) * (Random(0, 1) * 2 - 1),
        Randomf(cy + screen_height / 2, cy + screen_height / 2 - 50)
      )
    end
  end
end
